
\newpage
\part{Machine learning with Python}

\section{Introduction}

\subsection{Artificial Intelligence... really ?}
Today, a lot of noise is generated concerning Artificial Intelligence
(AI) and machine learning. To help us decreasing this noise, we will
study, from scratch, the fundamental of neural network. Be aware, I am
not a specialist of this topic. As numerical scientist enthusiast, I
am curious about IA. That's why, I spent some times for working on this
subject in order to get some understanding about how IA works. So,
this part is only an introduction to neural networks. In fact, I will
share with you what I have (approximately) understood.

Neural network is a special class of AI technology. Today,
\textit{convolutional} neural network seems to be one of the most
advanced IA techno. It allows \textit{deep learning} able to do very
impressive things. In my opinion, one of the most impressive thing that I found, is
the usage of deep learning for art generating. For example, \textit{deep dream}
\footnote{\url{https://deepdreamgenerator.com/}} is an AI able to
generate painting art by combining photos and human paintings. The results are
really amazing!

Indeed, IA algorithms need an impressive amount of data to be
efficient. In fact, AI is not a correct name because it gives a false
idea of how AI works and what AI can do. A more precise name is
\textit{machine learning algorithm}.

Okay, let's go... However, before beginning, let's clarifying the purpose of AI.


\subsection{The purpose of machine learning (and dinosaur)}
The aim of a neural network is to make \textit{predictions}. If you
are a scientist, you probably know the linear regression concept. This
mathematical tool allows us to make predictions. Imagine that your are a
paleontologist. You have collected several dinosaur bones and you put
them into the table below.

\begin{center}
  \begin{tabular}{lllcccc}
    dino         &     & $A$  & $B$  & $C$  & $D$  & $E$ \\\hline
    femur length (cm)   & $f$ & 38 & 56 & 59 & 64 & 74 \\\hline
    humerus length (cm) & $h$ & 41 & 63 & 70 & 72 & 84
  \end{tabular}
\end{center}


Now, you want to know if the dino $A$, $B$, $C$, $D$ and $E$ belong
to the same species (a class in fact).  As you probably know, the size of an individual
depends on both genetic factors and ages. So, let's do the assumption
that a linear factor $K$ exists between the femur $f$ and humerus $h$
sizes such as:
\begin{equation}
  h = K\times f \nonumber
\end{equation}
and the value of this factor $K$ is supposed to be a characteristic of
a given dinosaur species. Now, let's plot these data and the associated
linear regression... with python of course \texttt{:)}!
\vspace*{-1\baselineskip}
\begin{lstlisting}
from matplotlib import pyplot as plt
import numpy as np
x = [38, 56 , 59 , 64 , 74]
y = [41 ,63 , 70 , 72 , 84]
fit = np.polyfit(x,y,1) # linear regression here
fit_fn = np.poly1d(fit) # put it as lambda expression
plt.plot(x,y, 'bo', x, fit_fn(x), '--k')
plt.xlabel('Femur size (cm)')
plt.ylabel('Humerus size (cm)')
plt.show()
\end{lstlisting}
It gives the following plot:
\begin{center}
  \svg{0.75\linewidth}{./img/dino.pdf_tex}
\end{center}
On this plot, it is clear that some doubts exist on the dino $C$
because the point $C$ is far from the linear regression line. So, we can
suppose that the dino $C$ may not belong to the same species than
other dino.

In fact, we do here a \textit{binary classification}: we try to deduce
if a point belongs to a certain class or not. This kind of problem can
be easily tackled with the most simple neural network. We will study
this neural network in details in the next section.

\section{Single layer neural network (Rosenblatt's Perceptron)}
The previous example can be tackled manually because the data sample
is small. Indeed, if you want to automatize this process for a large amount
of data, you need to automatize it with a program. In 1957, The
Rosenblatt's perceptron \cite{rosenblatt1957perceptron} was the first
learning machine. As shown on picture \ref{fig:perceptron}, it was
really a machine!

\begin{figure}[h]
  \begin{center}
    \includegraphics[width=.5\linewidth]{perceptron}
    \caption{The Rosenblatt's perceptron machine in 1957\label{fig:perceptron}}
  \end{center}
\end{figure}

Here, we will see the most simple example of \textit{supervised
  training}. It means that the machine will be trained with input data
(noted $\mathbf{x}$) that has already been classified (noted
$\mathbf{t}$). For example, the next figure shows an example of
already-classified data. Here, for the sake of clarity, the data
$\mathbf{x}$ are in two dimensions. Each point of the data is defined
by 2D coordinates $(x_{0}, x_{1})$ and each point is associated with a class. The
class is defined by a label $t$ that takes the '1' or '0' value.

\begin{center}
  \svg{0.5\linewidth}{./img/perceptron-plot.pdf_tex}
\end{center}


The workflow of the supervised machine learning is simple:
\begin{enumerate}
\item training the machine with already-classified data and
\item make prediction with non-classified data.
\end{enumerate}

Figure \ref{fig:perceptron} describes the Rosenblatt's Perceptron
architecture. The output is generated from the input through two
functions: the \textit{transfer function} and the \textit{activation
  function}. The weights $w_{i}$ are the coefficients that must be
trained and adjusted during the learning step.

\begin{figure}[h]
  \begin{center}
    \svg{0.9\linewidth}{./img/perceptron-scheme2.pdf_tex}
  \end{center}
  \caption{Overview of the Perceptron architecture \label{fig:perceptron}}
\end{figure}

The goal of the training step is to deduce the best weight values from
already-classified data. In the original Perceptron, these weights was
generated through mechanical potentiometers and their values were automatically
adjusted with motors!

\subsection{The feed forward rule}
The \textit{feed forward} rule is the rule that makes output value(s)
from input values. It induces different mathematical
processes and computations. In the Perceptron algorithm, two computations are
processed given by two different functions: the \textit{transfer}
function and the \textit{activation} function.


\subsubsection{The transfer function \label{sec:transfer-perceptron}}
The \textit{transfer function} makes a linear combination of the
inputs $(x_0, x_1, \dots, x_n)$ with the weights
$(w_0, w_1, \dots, w_n)$ and a single coefficient $b$ named
\textit{bias}. The transfer function is:
\begin{equation}
  a(x_i) = b + x_0 w_0 + x_1 w_1 + \dots + x_n w_n = b + \sum\limits_{i=1}^{n}( x_i w_i)\nonumber
\end{equation}
We can simplify the mathematical written by expressing inputs
$\mathbf{x}$ and weights $\mathbf{w}$ with vectors:
\begin{align}
  \mathbf{x} = 
  \begin{bmatrix}
    x_{0}  \\
    x_{1}  \\
    \vdots \\
    x_{n} 
\end{bmatrix}
  \quad \text{and} \quad
  \mathbf{w} =
  \begin{bmatrix}
    w_{0}  \\
    w_{1}  \\
    \vdots \\
    w_{n} 
\end{bmatrix}\nonumber
\end{align}
Now, the transfer function $a$ can be written as:
\begin{equation}
  a( \mathbf{x}, \mathbf{w}, b)  = \mathbf{x} \cdot \mathbf{w} + b\label{eq:net-input-perceptron}
\end{equation}
where $\cdot$ is the scalar (or dot) product between two vectors.

Note that the transfer function gives a scalar $a$. This function is
\textbf{really important}. It allows us to make linear combination of
entries. This function is already used even in complex modern neural networks such
as convolutional neural networks used in deep learning.


\subsubsection{The activation function \label{sec:activation-perceptron}}
The second function is called \textit{activation function}. This is
always a non-linear function. In our case (the original Perceptron),
the activation function is the output of the Perceptron and must
be able to separate the two classes with \texttt{'1'} nor \texttt{'0'} values. The
\textit{unit step function} can do this job. The unit step function is defined as:
\begin{equation}
  z(a) = \left\{
    \begin{array}{rl}
         1 & \mbox{if } a>0 \\
         0 & \mbox{otherwise}
    \end{array}
\right.\nonumber
\end{equation}
Graphically, the unit step function gives:
\begin{center}
  \svg{0.2\linewidth}{./img/unit-step.pdf_tex}
\end{center}



\subsection{The backward propagation rule}
At this step, we are able to compute an output $y$ that takes \texttt{'1'} nor
\texttt{'0'} values from an input $\mathbf{x}$. However, the weights
$\mathbf{w}$ has not been trained and the computed output is
irrelevant. The backward propagation rule allows to deduce the best
fit weights from already-classified data.

The rule proposed by Rosenblatt is quit simple. For each input data
$\mathbf{x}$, the weight $\mathbf{w}$ and bias $b$ are adjusted with a
small correction $\mathbf{\Delta w}$ and
$\Delta b$ as follows:
\begin{align}
  \mathbf{w} &\rightarrow \mathbf{w} + \eta \mathbf{\Delta w}\\\nonumber
  b &\rightarrow b + \eta \Delta b\nonumber
\end{align}
where $\eta$ is a coefficient named the \textit{learning rate}. Note that $\eta$ is a scalar.
Rosenblatt has proposed to deduce these corrections from the following rules:
\begin{align}
  \Delta w_0 &= \eta\left(t-y \right)x_0 \nonumber\\ 
  \Delta w_1 &= \eta\left(t-y \right)x_1 \nonumber\\
  \vdots &\nonumber\\
  \Delta w_n &= \eta\left(t-y \right)x_n \nonumber\\ 
  \Delta b   &= \eta\left(t-y \right) \nonumber
\end{align}
where $t$ is the target value and $y$ is the output of the
Perceptron. The above formula can be written in vectorial form as:
\begin{align}
  \mathbf{\Delta w} &= \eta\left(t-y \right)\mathbf{x} \nonumber\\ 
  \Delta b          &= \eta\left(t-y \right) \nonumber
\end{align}
With this learning rule, if $t=y$ the weights are not modified. If
$t\neq y$ the weight values are adjusted. This trick allows to
increase or decrease the weights in the direction of the target
value. The rate of these modifications can be adjusted thanks to the $\eta$
coefficient.


\subsection{Let's coding!}
In addition of \textit{matplotlib} and \textit{numpy}, we will use the
\texttt{scikit-learn}
\footnote{\url{https://scikit-learn.org/stable/}} and the
\texttt{mlxtend} \footnote{\url{http://rasbt.github.io/mlxtend/}}
modules for generating and visualizing data. The following python code
generates pseudo-randomized data thanks to the \texttt{make\_blobs(...)}
function that comes from \texttt{sklearn} module.  These data are
finally plotted with the \texttt{plot\_decision\_regions(...)} function that comes
from \texttt{mlxtend} module.

\iascript{perceptron-data.py}


In the above code, data are generated with the
\texttt{make\_blobs(...)} function. This function returns two
parameters. Here these parameters are taken as variables named
\texttt{data} and \texttt{label}. Let's monitor these variables with
the interpreter.
\vspace*{-1\baselineskip}
\begin{lstlisting}
>>> type(data)
<type 'numpy.ndarray'>
>>> data.shape
(1000, 2)
\end{lstlisting}

\begin{info}
  If you want to stop the execution of a python script at a given step of your
  code, you just have to insert the
  \texttt{code.interact(local=locals())} function that comes from the
  \texttt{code} module.
\end{info}


Here, you can see that \texttt{data} is a numpy array. The first axis
length (1000) corresponds to the number of points specified with the
\texttt{n\_samples} argument of the \texttt{make\_blobs(...)} function. The
second axis length corresponds to the (2D) coordinates of each
point that corresponds to the \texttt{n\_features} argument of the
\texttt{make\_blobs(...)} function. Here, we have chosen two dimensions for an
easy plotting of data. To summarize, \texttt{data} is simply an array that
contains 1,000 two dimensional data points.


In addition, these 1,000 data points are classified through the \texttt{label}
variable.
\vspace*{-1\baselineskip}
\begin{lstlisting}
>>> type(label)
<type 'numpy.ndarray'>
>>> label.shape
(1000,)
\end{lstlisting}
As you can see, the \texttt{label} variable contains the class (also
called label) of each 1,000 points. Here, it contains only two classes
identified by '0' or '1'. You can choose more classes with the
\texttt{centers} argument of the \texttt{make\_blobs(...)} function.

\begin{center}
  \includegraphics[width=.8\linewidth]{data-label}
\end{center}

The \texttt{make\_blobs(...)} function, that comes from the \texttt{sklearn}
module, generates data cloud (a blob) centered at a given location as shown on
Figure \ref{fig:blob}. This kind of data are \textit{linearly
  separable}. It means that a straight line (a linear function) is
able to separate (or classify) these kind of data. Note that this property can be generalized for
n-dimensional spaces with hyperplanes. 

\begin{figure}[h]
  \begin{center}
    \includegraphics[width=.8\linewidth]{blob}
    \caption{Example of labeled data generated with the \texttt{make\_blobs(...)} function \label{fig:blob}}
  \end{center}
\end{figure}


Now, we can apply the recipes given in sections
\ref{sec:transfer-perceptron} and \ref{sec:activation-perceptron} in
order to implement the Perceptron. It gives the following code.

\iascript{perceptron-init.py}

The image below plots the results of the above code. As you can
observe, the Perceptron is able to separate the variable with a
straight line. But.... how it really works?

\begin{center}
  \includegraphics[width=1.\linewidth]{result-perceptron}
\end{center}

Take a look at equation \ref{eq:net-input-perceptron}. We can write
this equation related to the net \textit{input function} with 2 dimensional data$(x_0,  x_1)$ as follow:
\begin{equation}
  a = x_0 w_0 + x_1 w_1 + b\nonumber
\end{equation}
Now, remember that the \textit{activation function} $z(a)$ (see
section \ref{sec:activation-perceptron}) consists in classifying data
depending on the sign of the input $a$ :
\begin{equation}
  z(a) = \left\{
    \begin{array}{rl}
         1 & \mbox{if } a>0 \\
         0 & \mbox{if }  a<0
    \end{array}
\right.\nonumber
\end{equation}

Here, we can take the frontier limit by posing $a$ nor negative and nor positive, i.e,  $a=0$. It gives:
\begin{equation}
  0 = x_0 w_0 + x_1 w_1 + b\nonumber
\end{equation}
Now, we can express $x_1$ as a function of $x_0$ as:
\begin{equation}
  x_1 = -x_0 \frac{w_0}{w_1} - \frac{b}{w_1} \label{eq:perceptron-line}
\end{equation}
This last equation is linear, we retrieve the well known form $y=mx+y_0$ where:
\begin{equation}
   m= -\frac{w_0}{w_1} \quad \text{and} \quad y_0= -\frac{b}{w_1} \nonumber
\end{equation}
So, if the values of the coefficients $w_0$, $w_1$ and $b$ are known,
we are able to plot the function $x_{1} = f(x_{0})$. The related function is
linear and  the related plot is a straight line. This straight line
separates the space in two half spaces:
\begin{enumerate}
\item the half space below the line corresponds to the case where $a>0$, e.g, the \texttt{'1'} class and
\item the half space above the line corresponds to the case where $a<0$, e.g, the \texttt{'0'} class.
\end{enumerate}

\begin{manip}
  To verify the above assumption, you can try to plot the related equation \ref{eq:perceptron-line}.
  You must obtain something like this (dash dot line named \textit{Replot}).
  \begin{center}
  \includegraphics[width=.8\linewidth]{result-perceptron-1}
\end{center}
\end{manip}



\subsection{Converging rate, error and epoch}
Let's interested us to the error that appears during the learning process and how
the Perceptron algorithm converges toward a solution.  The graph below
plots the data and the cumulative errors made during the learning
process. \textit{Cumulative errors} means that each time the
Perceptron gives the wrong answer during the learning process, the
related error increments its value of one. Here, the cumulative error
is a measure of the learning process rate of the machine.
\begin{center}
  \svg{1.\linewidth}{./img/perceptron-converge-good.pdf_tex}
\end{center}
In this above case, the Perceptron made only one mistake on the whole
1,000 data sample and the result looks really good. In fact, this good
result is given because data are easily linearly separable. Let's see a
more complicated example with an overlapping zone between the two
classes as shown below.
\begin{center}
  \svg{1.\linewidth}{./img/perceptron-converge-bad.pdf_tex}
\end{center}
In this new sample, an overlapping zone exists and the data are not
clearly linearly separable. As, you can see, the results given by the
Perceptron is bad because the separated line is not well placed. This
bad result is also highlighted on the cumulative errors evolution that
rises up continuously. In order to minimize this error, let's try to
pass again the whole data sample into the learning process. The number
of loop where the whole data sample are processed in the learning process
is called \textbf{epoch}. The following charts show the results for 100 epochs!
\begin{center}
  \svg{1.\linewidth}{./img/perceptron-converge-bad-100-epoch.pdf_tex}
\end{center}
As you can see, the results is quiet better: the frontier between the
two classes looks better than the previous one.  
\begin{info}
  This data set are available at the following urls:\\
  \texttt{1:}\dlIA{perceptron-x.dat}\\
  \texttt{2:}\dlIA{perceptron-y.dat}\\
  \texttt{3:}\dlIA{perceptron-label.dat}\\
  If you want to use this data set, please download these three files,
  put them into your current directory and add the
  following lines to your script file: \vspace*{-1\baselineskip}
  \begin{lstlisting}
# load the data from files
x  = np.fromfile('perceptron-x.dat')
y  = np.fromfile('perceptron-y.dat')
label = np.fromfile('perceptron-label.dat', dtype=int)
data = np.stack((x, y), axis=-1)
\end{lstlisting}
\end{info}

So, the epoch trick gives here better results. The listing
below shows the implementation of the Perceptron with
epochs.

\lstinputlisting[firstline=15, lastline=31, caption=\dlIA{perceptron-error.py}]{../script/ia/perceptron-error.py}


However, as you can see on the previous graphs, the cumulative error seems to
linearly increase and do not stabilize toward a single value. This is
normal, because as you can see on the previous figure some points are
misclassified. It generates single errors that accumulate and induce a
regular increase of the cumulative error curve. In fact, in this special
case, the data are not fully linearly separable. That's why these errors are
unavoidable.

Indeed, a better approach consists in generating a score between the
$[0, 1]$ range that allows us to generate a probability that a point
belongs to one of these two classes.
\begin{itemize}
\item A score closes to $0$ means that a
  point as a high probability to belong to the \texttt{'0'} class.
\item A score closes to $1$ means that a point as a high probability
  to belong to the \texttt{'1'} class.
\end{itemize}
The unit step function can not do this job because it only gives two
discrete values: $0$ or $1$. A good function to do this job, is the
\textit{sigmoid function} described in the next section.


\section{Sophisticated backpropagation step with gradient descent}
\subsection{Implementing the sigmoid function}
The following figure shows the main difference between the unit step
function and the \textit{sigmoid} function.
\begin{center}
  \svg{.4\linewidth}{./img/sigmoid.pdf_tex}
\end{center}
The main differences between these two functions are:
\begin{enumerate}
\item the unit step function is a discrete function which gives only
  $0$ or $1$ values from $\mathbb{R}$ and
\item the sigmoid function is a continuous non-linear function which
  gives any values in the $[0,1]$ range from $\mathbb{R}$.
\end{enumerate}
The unit step function is \textit{non-derivable}
whereas sigmoid function is \textit{derivable}. The equation of the
sigmoid function is given by:
\begin{equation}
  \sigma(x) = \frac{1}{1+e^x}\nonumber
\end{equation}
and its derivative is given by:
\begin{equation}
  \sigma'(x) =  \sigma(x)\ \left(1-\sigma(x)\right)\nonumber
\end{equation}
Using sigmoid as activation function can be viewed as introducing
probability in our machine:
\begin{enumerate}
\item if the sigmoid function gives a value close to $1$, it means that
  the related point has a strong probability to belong to the
  \texttt{'1'} class and
\item if the sigmoid function gives a value close to $0$, it means that
  the related point has a strong probability to belong to the
  \texttt{'0'} class,
\item otherwise the point can not be defined and a high uncertainty remains
  on its class.
\end{enumerate}
A simple approach consists in defining thresholds in order to classify
input. For example, as shown on the figure below, we consider a threshold of 20\%.
It means that:
\begin{enumerate}
\item if the score is lower than $0.2$, the point is considered as belonging to the \texttt{'0'} class,
\item if the score is higher than $0.8$, the point is considered as belonging to the \texttt{'1'} class,
\item otherwise the point class is considered as uncertain.
\end{enumerate}

\begin{center}
  \svg{.4\linewidth}{./img/sigmoid-class.pdf_tex}
\end{center}

This approach allows us to make three different zones. With the
previous data set, it gives the following chart.
\begin{center}
  \svg{.6\linewidth}{./img/perceptron-sigmoid.pdf_tex}
\end{center}
The next listing shows the implementation of the sigmoid function in the Perceptron.

\lstinputlisting[firstline=24, lastline=50, caption=\dlIA{perceptron-sigmoid.py}]{../script/ia/perceptron-sigmoid.py}

Another advantage of using this kind of continuous function comes from
that the sigmoid function is fully \textbf{derivable}. This property
can be used advantageously for optimizing the backward propagation
process with the \textit{gradient descent} algorithm and loss
functions. The next section will introduce this highly important
concept in ML: gradient descent algorithm.





\subsection{The gradient descent algorithm}
As illustrated in two dimensions on the next figure, the gradient
descent algorithm is an iterative algorithm able to find the minimum
of a derivable function $f(x)$.
\begin{center}
  \svg{.6\linewidth}{./img/gradient-descent.pdf_tex}
\end{center}

It computes, from a starting point $M_0$ that belongs to $f(x)$ (the
function to find the minimum), a next point by \textit{descending} the
tangent. The tangent at $M_0$ is given by the first order derivative
of the function $f'(x_0)$. This process is repeated until the
algorithm converge to a single point that means that the algorithm find a
\textit{local minima}. In a similar way of the Perceptron, the
convergence rate can be adjusted with a coefficient noted $\eta$. The
algorithm is quite simple and can be described with the following
recursive formula:
\begin{equation}
  x_{k+1} = x_k - \eta f'(x_k)
\end{equation}
where $k$ is the step number of the computation and $x_k$ is the X
axis value at the $k$th step of the algorithm. The figure
\ref{fig:grad-2D} shows the converging rate of the gradient
descent algorithm. In this example, the function $f(x)$  is:
\begin{equation}
  f(x) = x^4 - 3x^3 + 2 \quad \text{and} \quad f'(x) = 4x^3 - 9x^2\nonumber
\end{equation}

On this plot, the orange points highlight
the different steps of the algorithm. It suggests that the points roll
down on the curve!  In fact, the gradient descent algorithm allows to
move the next point in a given \textit{direction} and an
\textit{intensity}. In 2D, only two directions are possible: move to
the left or move to the right whereas the intensity is related to the
step between two consecutive points. You can note that this step is
not constant (in contrast of the original Perceptron algorithm) and it
decreases while approaching the local minima. It means that the
recursive algorithm works well and converges toward the right minima
value. The related python code is given in the next listing.


\lstinputlisting[firstline=3, lastline=19, caption=\dlIA{gradient-descent.py}]{../script/ia/gradient-descent.py}

\begin{figure}[h]
\begin{center}
  \svg{.6\linewidth}{./img/gradient-descent1.pdf_tex}
  \caption{2D gradient descent algorithm in action for $f(x)=x^4 - 3x^3 + 2$\label{fig:grad-2D}}
\end{center}
\end{figure}


However, one notes that the algorithm can be trapped in a local minima
that do not correspond to the global minima of the function. For example, it
happens in the given example if you start the algorithm at $x_0 = -0.5$. A second
observation concerns the convergence rate $\eta$.  The algorithm may
diverge if $\eta$ is too high. So, small $\eta$ values ensure
convergence but the number of iteration to compute becomes high and
the algorithm slows down.

The gradient descent algorithm can also be applied in a 3 dimensional space.
Imagine that the function $f$ depends on two variables $x$
and $y$. So, $f(x,y)$ can be plotted as a surface in a three dimensional
space. In a 3 dimensional space, the gradient descent algorithm becomes:
\begin{equation}
  (x_{k+1},\ y_{k+1}) = (x_k,\ y_k) - \eta \nabla f(x_k,\ y_k)\nonumber 
\end{equation}
where $\nabla$ is the gradient operator:
\begin{equation}
  \nabla f(x,\ y) = \left( \frac{\partial f}{\partial x} , \ \frac{\partial f}{\partial y} \right)\nonumber 
\end{equation}
Let's try it on a practical example. Suppose the following function (see figure \ref{fig:grad-3D}):
\begin{align}
  f(x,y) &= \sin\left(0.1\ x^2 + 0.05\ y^2 + y\right)\nonumber
\end{align}
Here, the partial derivatives required for computing the gradient  $\nabla f(x,\ y)$ are:
\begin{align}
  \frac{\partial f}{\partial x} (x,y)&= \cos\left(0.1\ x^2 + 0.05\ y^2 + y\right) (0.1\ x)\nonumber \\
  \frac{\partial f}{\partial y} (x,y)&= \cos\left(0.1\ x^2 + 0.05\ y^2 + y\right) (0.05\ y + 1)\nonumber
\end{align}
From the above formula, the gradient descent algorithm can be
implemented. The next listing shows its implementation.

\lstinputlisting[caption=\dlIA{gradient-descent-3D.py}]{../script/ia/gradient-descent-3D.py}

This listing gives the figure \ref{fig:grad-3D} that shows the gradient descent
algorithm in action from the starting point $(-4,\ -0.5)$.
\begin{figure}[h]
  \begin{center}
    \svg{.6\linewidth}{./img/gradient-descent-3D.pdf_tex}
    \caption{3D gradient descent algorithm in action for $f(x,y)=\sin\left(0.1\ x^2 + 0.05\ y^2 + y\right)$\label{fig:grad-3D}}
  \end{center}
\end{figure}

In fact, the gradient descent algorithm can be generalized in $n$-dimensional
spaces. In $n$-dimensional spaces, the function $f$ can be a function of $n$
independent variables as:
\begin{equation}
  f(x_0,x_1,\dots,x_n) = f(\mathbf{x})\quad \text{where}\quad \mathbf{x}(x_0,x_1,\dots,x_n)\nonumber 
\end{equation}
the gradient descent algorithm can be simply written in a vectorial form as:
\begin{equation}
  \mathbf{x}_{k+1} = \mathbf{x}_k - \eta \nabla f(\mathbf{x}_k)\nonumber 
\end{equation}
where $\nabla f(\mathbf{x})$ is the gradient vector of $f$ defined as:
\begin{equation}
  \nabla f(\mathbf{x}) = \left( \frac{\partial f}{\partial x_0} , \ \frac{\partial f}{\partial x_1}, \dots ,  \frac{\partial f}{\partial x_n}\right)\nonumber 
\end{equation}

To summarize, at this point we have an algorithm able to find the minimum of a
continuum function in a $n$ dimensional spaces. The gradient descent
algorithm is extensively used in neural networks for minimizing loss
functions. The next section will describe this process.



\subsection{The loss function}

Loss functions are special functions able to measure the accordance of
a prediction with their target values. High scores indicate bad
predictions whereas low scores indicate good accordance of
predictions. A common loss function (noted $L$) often used in machine
learning is the Mean Square Error (MSE). The MSE function $L$ is defined as:
\begin{equation}
  L(\mathbf{y}) = \frac{1}{m} \sum\limits_{i=1}^{m} \left( y^{(i)} - t^{(i)} \right)^2\nonumber
\end{equation}
where $m$ is the total number of data points, $y^{(i)}$ and $t^{(i)}$ are related
to a unique instance of a prediction and its target value.

At this stage, it should be nice to remember the Perceptron
architecture. This architecture is highlighted on the above scheme.
\begin{center}
  \svg{.7\linewidth}{./img/perceptron-scheme-simple.pdf_tex}
\end{center}
Here, the idea of the back propagation step is to minimize the loss
function $L(\mathbf{y})$ in regard of weights $\mathbf{w}$. For sure, the
gradient descent algorithm can be used to make this job. So, the
gradient of the loss function in regard of weights have to be computed.
\begin{equation}
  \nabla L(\mathbf{w}) = \left( \frac{\partial L}{\partial w_0} , \ \frac{\partial L}{\partial w_1}, \dots ,  \frac{\partial L}{\partial w_n}\right)\nonumber 
\end{equation}
If we focus on the first component of the gradient $\nabla L(\mathbf{w})$, it gives:
\begin{align}
  \frac{\partial L}{\partial w_0}
  &= \frac{\partial}{\partial w_0}\left( \frac{1}{m} \sum\limits_{i=1}^{m} \left( y^{(i)} - t^{(i)} \right)^2 \right)\nonumber
 \end{align}
By the way, the derivative can be introduced in the sum as:
\begin{align}
  \frac{\partial L}{\partial w_0}
  &=  \frac{1}{m} \sum\limits_{i=1}^{m} \frac{\partial}{\partial w_0}\left( \left( y^{(i)} - t^{(i)} \right)^2\right)\nonumber
\end{align}
Following the Perceptron architecture, one notes that the output $y$
is a composed function of $z$ and $a$ as:
\begin{align}
  y &=y\left(\ z\ \right) \nonumber\\
    &=y\left(\ z(\ a\ )\ \right)\nonumber\\
    &=y\left(\ z\left(\ a(\mathbf{x}, \mathbf{w})\  \right) \ \right)\nonumber
\end{align}
So, the following derivative chain rule can be written:
\begin{align}
  \frac{\partial f}{\partial w_0} =
  \frac{\partial  f}{\partial  y}\cdot 
  \frac{\partial  y}{\partial  z}\cdot 
  \frac{\partial  z}{\partial  a}\cdot  
  \frac{\partial  a}{\partial  w_0} \quad \text{where} \quad
  f(y) = \left( y - t \right)^2\nonumber
\end{align}
The derivative of each chain item can be easily computed:
\begin{align}
  \frac{\partial  f}{\partial  y}   &= \frac{\partial}{\partial y}\left( \left( y - t \right)^2 \right) &=& 2(y-t)                &\rightarrow\quad& \text{\textit{derivative of loss function (MSE)}}\nonumber\\
  \frac{\partial  y}{\partial  z}   &= \frac{\partial}{\partial  z}\left(z  \right) &=& 1                                         &\rightarrow\quad& \text{\textit{derivative of output function (identity)}}\nonumber\\
  \frac{\partial  z}{\partial  a}   &= \frac{\partial}{\partial  a}\left(\sigma(a)\right) =\sigma(a)(1-\sigma(a)) &=& \sigma '(a)              &\rightarrow\quad& \text{\textit{derivative of activation function (sigmoid)}}\nonumber\\
  \frac{\partial  a}{\partial  w_0} &= \frac{\partial}{\partial  w_0}\left(b + x_0 w_0 + x_1 w_1 + \dots +  x_n w_n  \right) &=& x_0 &\rightarrow\quad& \text{\textit{derivative of transfer function}}\nonumber
\end{align}
We can combine all these derivatives in one single formula. It gives:
\begin{align}
  \frac{\partial L}{\partial w_0}
  &=  \frac{1}{m} \sum\limits_{i=1}^{m} 2(y^{(i)} - t^{(i)})\cdot 1\cdot \sigma '(a^{(i)})\cdot x_{0}^{(i)} \nonumber
\end{align}
This formula can be generalized to any weight $w_j$ as:
\begin{equation}
  \boxed{\frac{\partial L}{\partial w_j} =  \frac{2}{m} \sum\limits_{i=1}^{m} (y^{(i)} - t^{(i)})\cdot \sigma '(a^{(i)})\cdot x_{j}^{(i)}} \nonumber
\end{equation}
and for the bias $b$:
\begin{equation}
  \boxed{\frac{\partial L}{\partial b} =  \frac{2}{m} \sum\limits_{i=1}^{m} (y^{(i)} - t^{(i)})\cdot \sigma '(a^{(i)})} \nonumber
\end{equation}

\begin{info}
  Here, the trick for computing quickly the derivative of $L$
  regarding the bias $b$ is to consider $b$ as a weight where its
  entry is always equal to 1 (see \ref{fig:perceptron}).  Practically,
  in some machine learning frameworks, this feature is given by adding
  silently a new component to the $\mathbf{x}$ vector (which is always
  equal to a unit) and also to the weight $\mathbf{w}$ (which is equal
  to the bias). It gives:
  \begin{equation}
    a =
    \begin{bmatrix}
    1 \\x_0  \\ x_1  \\ \vdots \\ x_n
\end{bmatrix} \cdot \begin{bmatrix}
  b \\ w_0  \\ w_1  \\ \vdots \\ w_n
\end{bmatrix} = b + x_0 w_0 + x_1 w_1 + \dots + x_n w_n\nonumber
\end{equation}
So, it is equivalent to the classical transfer function. It allows to
remove the bias for avoiding its special treatment. This trick is
often used in the literature about neural network! For pedagogical
reason this trick will not be used in this document.
\end{info}

\begin{attention}
Don't be confuse, remember that $n$ is related to the dimension of the
entry vector $\mathbf{x}(x_0, x_1, \cdots , x_n$) whereas $m$ is
related to the number of entry points. In other words, the learning
step involves $m$ points of $n$-dimensions.
\end{attention}


\subsection{Implementation of the loss function and gradient descent algorithm}
We stated, from the previous sections, that optimal values of weights
and bias can be found thanks to the back propagation step that
implements the gradient descent algorithm. This algorithm gives:
\begin{align}
  w_0 &\rightarrow w_0 +  \frac{2\eta}{m} \sum\limits_{i=1}^{m} (y^{(i)} - t^{(i)})\cdot \sigma '(a^{(i)})\cdot x_{0}^{(i)} \nonumber\\ 
  \vdots \nonumber\\
  w_n &\rightarrow w_n +  \frac{2\eta}{m} \sum\limits_{i=1}^{m} (y^{(i)} - t^{(i)})\cdot \sigma '(a^{(i)})\cdot x_{n}^{(i)} \nonumber\\ 
  b   &\rightarrow b +  \frac{2\eta}{m} \sum\limits_{i=1}^{m} (y^{(i)} - t^{(i)})\cdot \sigma '(a^{(i)})  \nonumber
\end{align}
For the weight part, the related formula can be expressed in a vectorial form as:
\begin{equation}
 \mathbf{w} \rightarrow \mathbf{w} +  \frac{2\eta}{m} \sum\limits_{i=1}^{m} (y^{(i)} - t^{(i)})\cdot \sigma '(a^{(i)})\cdot \mathbf{x}^{(i)} \nonumber
\end{equation}
where $\mathbf{w}$ and $\mathbf{x}^{(i)}$ are $n$-dimensional
vectors. Now, as you can see in the above formula, we must implement a
summation on all the $m$ points. Based on this observation, the sum
can be replaced thanks to \textit{linear algebra} operation such as the
\textit{dot} products:
\begin{equation}
  \mathbf{w} \rightarrow \mathbf{w} +  \frac{2\eta}{m} \left(\mathbf{X}^\top   \cdot 
    \left[ \left(\mathbf{y} - \mathbf{t} \right)\circ
      \sigma\left(\mathbf{a}\right)\circ\left(1-\sigma\left(\mathbf{a}\right)\right) \right]
    \right)\nonumber
\end{equation}
where:
\begin{itemize}
\item $\mathbf{w}$, $\mathbf{y}$, $\mathbf{t}$ and $\mathbf{a}$ are $(n)$-dimensional vectors,
\item $\mathbf{X}$ is a $(n\times m)$-dimensional \textbf{matrix} (or tensor),
\item $^\top$ is the transpose of a matrix (or a vector), 
\item $\circ$ is the \textit{Hadamard} product (the so-called \textit{element wise} product) 
\item $\cdot$ is the dot product (here, the dot product replaces the sum), 
\item $n$ is the number of dimension of an entry $\mathbf{x}_i$ and 
\item $m$ is the total number of entry  $\mathbf{X}$.
\end{itemize}

\begin{info}
  Here, the advantage of using linear algebra (tensorial) operations such as
  \textit{Hadamard} or \textit{dot} products is to deal with large
  amount of data. Linear algebra computations involved in tensorial
  operations have been optimized for a long time and the main linear algebra algorithms
  can be massively parallelized in both CPU and GPU. Deep learning processes
  extensively use linear algebra computations. For example, the name
  of one of the must popular free deep learning framework (supported by
  Google) is ``\textit{TensorFlow}''. For now, \textbf{be aware}, to
  follow the next part of this document, you must be familiar with
  tensorial operations and linear algebra computation rules.
\end{info}

To clarify this last formula, we will take the first example of this
document that implements the following data:
\begin{center}
  \includegraphics[width=.6\linewidth]{data-label1}
\end{center}
Here, the number of dimension $n$ of an entry $\mathbf{x}_i$ is 2 and
the total number of entry $\mathbf{X}$ is 1,000. To summarize, in this
example, $n=2$ and $m=1,000$. Now, let's focus on the trick able to
replace a \textit{sum} by a \textit{dot product}. If we take the
current example, we can highlights the main terms of the previous
equation:
\begin{equation}
  \underbrace{\mathbf{w}}_{\begin{bmatrix}
  w_0  \\ w_1 \end{bmatrix}} \rightarrow \underbrace{\mathbf{w}}_{\begin{bmatrix}
  w_0  \\ w_1 \end{bmatrix}} +  \overbrace{\frac{2\eta}{m}}^{\text{scalar}} \times  \underbrace{\mathbf{X}^\top}_{\begin{bmatrix}
      x_{0_{0}}  & x_{0_{1}} & \dots & x_{0_{999}}\\  x_{1_{0}}  & x_{1_{1}} & \dots & x_{1_{999}}\end{bmatrix}
    } \cdot
    \underbrace{\left[ \left(\mathbf{y} - \mathbf{t} \right)\circ
      \sigma\left(\mathbf{a}\right)\circ\left(1-\sigma\left(\mathbf{a}\right)\right) \right]}_{\begin{bmatrix}
      a_0  \\ a_1 \\ \vdots \\ a_{999} \end{bmatrix}} 
    \nonumber
\end{equation}
However, it does not correspond to the internal way of vector storage
in Numpy. Numpy stores vectors as row vectors. So, the previous formula
has to be rewritten as follows:
\begin{equation}
  \underbrace{\mathbf{w}}_{\begin{bmatrix}
  w_0  & w_1 \end{bmatrix}} \rightarrow \underbrace{\mathbf{w}}_{\begin{bmatrix}
  w_0  & w_1 \end{bmatrix}} +  \overbrace{\frac{2\eta}{m}}^{\text{scalar}} \times
    \underbrace{\left[ \left(\mathbf{y} - \mathbf{t} \right)\circ
      \sigma\left(\mathbf{a}\right)\circ\left(1-\sigma\left(\mathbf{a}\right)\right) \right]^\top}_{\begin{bmatrix}
      a_0  & a_1 & \dots & a_{999} \end{bmatrix}} \cdot \underbrace{\mathbf{X}}_{\begin{bmatrix}
      x_{0_{0}}  & x_{0_{1}} \\  x_{1_{0}}  & x_{1_{1}} \\ \vdots &  \vdots \\ x_{999_{0}}  & x_{999_{1}}\end{bmatrix}
    }
    \nonumber
\end{equation}

So, the gradient descent algorithm in Python can be written as:
\begin{equation}
  \boxed{
    \mathbf{w} \rightarrow \mathbf{w} +  \frac{2\eta}{m} \times
    \left[ \left(\mathbf{y} - \mathbf{t} \right)\circ
      \sigma\left(\mathbf{a}\right)\circ\left(1-\sigma\left(\mathbf{a}\right)\right) \right]^\top
    \cdot \mathbf{X}}
  \nonumber
\end{equation} 

The next listing shows the implementation of the modified Perceptron
algorithm with gradient descent and sigmoid activation function.

\lstinputlisting[firstline=15, lastline=45, caption=\dlIA{perceptron-sigmoid-gradient-descent.py}]%
{../script/ia/perceptron-sigmoid-gradient-descent.py}

You can note that the related code records the evolution of the loss
function into the \texttt{loss} array. This is very important. It
allows to check if the learning process is going right! The following
graph shows an example of a ``good'' loss evolution.
\begin{center}
  \svg{.5\linewidth}{./img/loss.pdf_tex}
\end{center}
As you can see the loss decreases continuously toward zero while the
epoch number increases. It means that the back propagation algorithm is
working as expected: it minimizes the loss by adjusting weights and
bias values in a correct way thanks to the gradient descent algorithm.


\subsection{Stochastic gradient descent algorithm with mini-batch}
When the amount of data is very large, it may be difficult to treat
all the data in one step. To avoid memory problem, the data could be
sliced in $k$ mini-batches. The following picture illustrates the
mini-batch process. Here the data are sliced in two separated mini-batch.
\begin{center}
  \includegraphics[width=.6\linewidth]{data-mini-batch}
\end{center}
Another good reason for using mini-batches is for optimizing the
gradient descent algorithm. As you know, gradient descent algorithm
can be trapped in a local minima. Using mini-batch allows to introduce
\textit{noises} in the algorithm. It increases the chance to find the
global minima instead of a local one. This process is called \textit{stochastic gradient
  descent algorithm}. It is simple, elegant and really efficient!
This strategy is massively used in machine learning. It consists in:
\begin{enumerate}
\item randomizing the data storage. It means that data arrays are shuffled.
\item slicing the newly organized data and label. 
\end{enumerate}

\subsubsection{Shuffling data with numpy}
Since the beginning of this document, we have seen that data are stored in two arrays:
\begin{enumerate}
\item the \texttt{data} array that contains the entry point and
\item the \texttt{label} array that contains the target values.
\end{enumerate}
The shuffling operation consists in reordering randomly these arrays. Indeed,
special attention must be taken. The shuffling operation must keep the
correspondence between the indices of the \texttt{data} and the \texttt{label}
arrays. The next figure summarizes this process. 
\begin{center}
  \svg{0.75\linewidth}{./img/shuffle.pdf_tex}
\end{center}
Again, Numpy gives all we need! Let's make a sample code into the
interpreter: \vspace*{-1\baselineskip}
\begin{lstlisting}
>>> data = np.arange(0,100,10)
array([ 0, 10, 20, 30, 40, 50, 60, 70, 80, 90])
>>> label = np.arange(0,1000,100)
array([  0, 100, 200, 300, 400, 500, 600, 700, 800, 900])
\end{lstlisting}
Now, we create a new array that contains the index of the
\texttt{data} and \texttt{label} arrays:
\vspace*{-1\baselineskip}
\begin{lstlisting}
>>> s = np.arange(data.shape[0])
array([0, 1, 2, 3, 4, 5, 6, 7, 8, 9])
\end{lstlisting}
Let's shuffling this array thanks to the \texttt{np.random.shuffle} function:
\vspace*{-1\baselineskip}\begin{lstlisting}
>>> np.random.shuffle(s)
>>> s
array([7, 0, 9, 5, 8, 4, 2, 6, 1, 3]) 
\end{lstlisting}
Now, we can use this shuffled arrays as indices for re-organizing the
\texttt{data} and \texttt{label} arrays as follow:
\vspace*{-1\baselineskip}\begin{lstlisting}
>>> data[s]
array([70 , 0, 90 , 50 , 80 , 40 , 20 , 60 , 10 , 30])
>>> label[s]
array([700, 0, 900, 500, 800, 400, 200, 600, 100, 300])
\end{lstlisting}
As you can see both \texttt{data} and \texttt{label} has been
reorganized with the same indices. It is very important, because we
need to keep the correspondence between the items contained in
\texttt{data} and \texttt{label}. Now, we want to slice these new
arrays in five mini-batches. We can use the \texttt{np.split} function as:
\vspace*{-1\baselineskip}\begin{lstlisting}
>>> mb = 5 # number of mini-batch 
>>> data_s = np.split(data[s], mb)                                                                                                  
[array([70,  0]), array([90, 50])  , array([80, 40])  , array([20, 60])  , array([10, 30])]
>>> label_s = np.split(label[s], mb)                                                                                                
[array([700, 0]), array([900, 500]), array([800, 400]), array([200, 600]), array([100, 300])]
\end{lstlisting}
Here, we have built five mini-batches with shuffled
data. Now, we can introduce these shuffled data into the modified
Perceptron algorithm. The next listing shows the
implementation of the stochastic gradient descent algorithm into
a modified Perceptron algorithm.

\lstinputlisting[firstline=30, lastline=60, caption=\dlIA{perceptron-sigmoid-gradient-descent-mini-batch.py}]%
{../script/ia/perceptron-sigmoid-gradient-descent-mini-batch.py}

The related algorithm gives the following evolution of loss (left image).
\begin{center}
  \svg{.48\linewidth}{./img/loss-stoch.pdf_tex}
  \svg{.48\linewidth}{./img/loss.pdf_tex}
\end{center}
As you can see, the evolution is a little bit noisy but the stochastic
gradient descent method is quicker than the non-stochastic one.



\section{A note on pre-processing data}
Preparing the data is really important for machine learning. So, please remember
this simple law: \textbf{bad data = bad predictions}.  In real life, this
process is the most time-consuming step of machine learning. You need
to automatize the process of collecting data, removing outlier points,
removing non-useful data and so on... It can be really complicated!

In this document, we deal only with already-prepared data available in
machine learning frameworks. By consequent, this preliminary work,
that consists in cleaning data, was already done for you. In this
document, we will not focus on this particular job. However, you have
to keep in mind that this is a very important work that must be done
on real data set.

However, even if your data is clean, you can apply some numerical
treatments in order to optimize the learning process. This step is
called \textit{feature scaling}.  It consists in scaling data in a
reasonable range close to $[0, 1]$. This process allows to facilitate
the learning step.

Several method exists. To get an overview, you can visit the
\textit{wikipedia page}
\footnote{\url{https://en.wikipedia.org/wiki/Feature_scaling}} that
describes several methods. My favorite choice came from philosophical
reason: in science, it is considered that \textit{nature} often gives
us data that follows normal distributions. In such cases, a good
\textit{feature scaling} is the \textit{standardization} defined as:
\begin{equation}
  x \rightarrow \frac{x - \bar{x}}{\sigma}
\end{equation}
where $x$ are the original data, $\bar{x}$ the mean data value and
$\sigma$ the standard deviation. Thanks to numpy,
\textit{standardization} is really easy to obtain:
\vspace*{-1\baselineskip}
\begin{lstlisting}
x = (x - x.mean()) / x.std() 
\end{lstlisting}
where \texttt{x} is a numpy array that contains data set.



\subsection{The complete code of the modified Perceptron algorithm}
At this time, we have learned a lot of things. Based on the original
Perceptron algorithm which is the most simple neural network, we have seen
how the learning process thanks to the feed forward and back
propagation step. This architecture is very general and should be
applied to a wide range of machine learning strategies. After that,
thanks to differentiable activation functions such as sigmoid
function, we have seen an optimal back propagation strategy that
implements loss function and stochastic gradient descent algorithm
with mini-batches. Finally, we have discussed shortly about data
preparation. All these ingredients enable the implementation of a
complete mono-neural network Perceptron as shown on the next listing.

\lstinputlisting[firstline=5,caption=\dlIA{perceptron-complete.py}]%
{../script/ia/perceptron-complete.py}

As you can see, a single neural network
is not very hard to implement, therefore it uses a lot of tips and
tricks. A last trick used in this listing is to initialize the weights to random values
in the range $[0,1]$. It allows to optimize the stochastic gradient
descent algorithm \textbf{for already scaled data}.  

\begin{manip}
  Now, as an exercise, you can try to implement the proposed
  Perceptron code (see previous listing) into a Python \textit{class}
  (see section \ref{sec:oo} about object oriented programming).  After
  that, you can use this class to solve linear multi-classification
  problems with several instances of Perceptron (one for each
  class). For three classes problem you must obtain something like
  this:
\begin{center}
  \includegraphics[width=.6\linewidth]{multi-class-perceptron}
\end{center}
\textbf{Correction is available here }: \dlIA{perceptron-multi-class.py}

\end{manip}

The further sections of this document will be dedicated to multiple
labels (more than two classes) classification and non linearly separable data using
multi-layer neural networks.



\section{Multi-layer neural networks}
At this step, we are able to classify linearly separable data in
multiple classes. Indeed, in many cases, for real complex problems,
the related data are not fully linearly separable. In such problems,
multi-layer neural networks can be used.

To illustrate non-linearly separable data problems, we will use
here another data set generator. Instead of the
\texttt{datasets.make\_blobs} function we will use the
\texttt{datasets.make\_moons} function.
\begin{manip}
  To test it by yourself, replace the \texttt{datasets.make\_blobs}
  function by the \texttt{datasets.make\_moons} inside the initial
  Perceptron code : \dlIA{perceptron-init.py}.
\end{manip}

As a result, it should give the following chart:
\begin{center}
  \includegraphics[width=.6\linewidth]{moon}
\end{center}
As you can see, this data set is not linearly separable. So, our
Perceptron algorithm is not able to classify correctly this kind of
data.  To solve this problem, we should implement multi-layer dense
neural networks. This kind of networks is able to deal with
non-linear problems.

In fact, our well-known Perceptron algorithm can be seen as a
fundamental brick for building multi-layer neural networks able to deal
with complex problems.  Here, we are going to build a two layers dense
neural network to solve this particular problem. Now, we will draw a
neuron as follow:
\begin{center}
  \svg{0.75\linewidth}{./img/neuron.pdf_tex}
\end{center}
Here, a neuron is drawn as a circle that contains the transfer function
$a(x)$ and the activation function $z(a)$. A neuron accepts multiple inputs and
gives one output. To solve our non-linear classification problem with
the \textit{moon} data set, we will implement the following
architecture:
\begin{center}
  \svg{0.75\linewidth}{./img/multi-layer.pdf_tex}
\end{center}
\begin{itemize}
\item The input layer $\mathbf{x}$ is connected to three neurons. This neuron layer
  is called \textit{hidden} layer.
\item The \textit{hidden} layer neurons are connected to one neuron
  called \textit{output} layer.
\end{itemize}
This network forms a \textit{dense multi-layer} neural network able to
deal with non-linear separable data set. A special attention must be
given to the number of related weights and biases. In a general manner,
imagine a layer of rank $l-1$ densely connected to its next layer of
rank $l$. Now, suppose that the number of neurons that compose the
layer of rank $l$ is noted $N_l$. By the way, the total number of
weight $N_{(l-1) \rightarrow (l)}$ that connect the layer of rank $(l-1)$ to its next
one $(l)$ is:
\begin{equation}
  N_{(l-1) \rightarrow (l)} = N_{l-1} \times N_{l}\nonumber
\end{equation}
If we apply this simple formula to our architecture, the numbers of weight for each connection are:
\begin{align}
  N_{0 \rightarrow 1} &= N_{0} \times N_{1} = 2\times 3 = 6\nonumber \\
  N_{1 \rightarrow 2} &= N_{1} \times N_{2} = 3\times 1 = 3\nonumber
\end{align}
Instead of storing the weights as vector, a more practical data storage involves
matrices. So, these weights can be written as matrices where
:
\begin{itemize}
\item the length of the first axis is the number of neuron $N_{l-1}$ of its
  entry layer and
\item the length of the second axis is the number of neuron $N_l$ of the output  layer.
\end{itemize}
In the above case, it gives:
\begin{equation}
  \mathbf{W}_{1} = 
  \begin{bmatrix}
    w_{1_{11}}  & w_{1_{21}}  & w_{1_{31}} \\
    w_{1_{12}}  & w_{1_{22}}  & w_{1_{32}}
  \end{bmatrix}
  \quad \text{and}\quad \mathbf{W}_{2} =
  \begin{bmatrix}
    w_{2_{11}}  \\
    w_{2_{12}}  \\
    w_{2_{13}} 
\end{bmatrix}\nonumber
\end{equation}

\begin{info}
  Note on mathematical conventions:
  \begin{itemize}
  \item scalars are written as italic-lowercase typeface, e.g,  $w$
  \item vectors are written as bold-lowercase typeface, e.g, $\mathbf{w}$
  \item matrices or tensors are written as italic-uppercase typeface, e.g, $\mathbf{W}$
  \end{itemize}
\end{info}

In general manner, weight matrices $\mathbf{W}_{l}$ (from layer $l-1$ to layer $l$) are written as:
\def\matriximg{%
  \begin{matrix}
    w_{l_{11}} & w_{l_{21}} & \cdots & \cdots &w_{l_{k1}}  \\
    w_{l_{12}} & w_{l_{22}} & \cdots & \cdots &w_{l_{k2}}  \\
    \vdots     & \vdots     & \cdots & \cdots &\vdots      \\
    w_{l_{1j}} & w_{l_{2j}} & \cdots & \cdots & w_{l_{kl}}  \\
   \end{matrix}
}%
\begin{equation}
  \text{\scriptsize $l$ rows = entry number $N_{l-1}$}\left\{\left[\vphantom{\matriximg}\right.\right.\kern-2\nulldelimiterspace
  \overbrace{\matriximg}^{\text{\scriptsize $k$ col = output number $N_{l}$}}\kern-\nulldelimiterspace\left.\vphantom{\matriximg}\right] = \mathbf{W}_{l}\nonumber
\end{equation}
Now, we will show how to implement the feed forward step with matrices.

\subsection{Initialization and implementation of the feed forward step}
We will move on higher level of abstraction. A more convenient
and general point of view is adopted by using matrices instead of
vectors or scalars. Each layer is considered as a box where inputs and
outputs are highlighted by arrows. With this new visualization, the
previous neural network scheme becomes:
\begin{center}
  \svg{1\linewidth}{./img/multi-layer-2.pdf_tex}
\end{center}
Here, single neurons are hidden; all the symbols are considered as
matrices instead of scalars and vectors. Let's detail the matrix shapes
associated to each symbols of the above diagram. For the current
example it gives the following shapes.
\begin{itemize}
\item $\mathbf{X}$ is a $(2\times m)$ matrix because it contains the $m$ points of the mini-batch as follows:
    \begin{equation}
  \mathbf{X} = 
  \begin{bmatrix}
    x_{1}^{(1)}   & x_{2}^{(1)} \\
    \vdots  & \vdots \\
    x_{1}^{(m)}   & x_{2}^{(m)}  \\
  \end{bmatrix}
\end{equation}
%   \def\matriximg{%
%   \begin{matrix}
%     x_{11} & x_{21}  \\
%     x_{12} & x_{22}  \\
%     \vdots & \vdots  \\
%     x_{1m} & x_{2m}  \\
%    \end{matrix}
% }%
%   \begin{equation}
%   \text{\scriptsize $m$ entry points}\left\{\left[\vphantom{\matriximg}\right.\right.\kern-2\nulldelimiterspace
%   \overbrace{\matriximg}^{\text{\scriptsize entry coordinates}}\kern-\nulldelimiterspace\left.\vphantom{\matriximg}\right] = \mathbf{X}\nonumber
% \end{equation}

\item $\mathbf{A_1}$ and $\mathbf{A_2}$ are respectively $(m\times 3)$ and $(m\times 1)$ matrices as follows:
  \begin{equation}
  \mathbf{A}_{1} = 
  \begin{bmatrix}
    a_{1_{1}}^{(1)}  & a_{1_{2}}^{(1)} & a_{1_{3}}^{(1)}\\
    \vdots    & \vdots   & \vdots \\
    a_{1_{1}}^{(m)}  & a_{1_{2}}^{(m)}  & a_{1_{3}}^{(m)} \\
  \end{bmatrix}
  \quad \text{and}\quad \mathbf{A}_{2} =
  \begin{bmatrix}
    a_{2}^{(1)} \\ 
    \vdots \\
    a_{2}^{(m)} 
\end{bmatrix}\nonumber
\end{equation}

\item $\mathbf{Z_1}$ and $\mathbf{Z_2}$ are respectively $(m \times 3)$ and $(m\times 1)$ matrices as follows:
  \begin{equation}
  \mathbf{Z}_{1} = 
  \begin{bmatrix}
    z_{1_{1}}^{(1)}  & z_{1_{2}}^{(1)}  & z_{1_{3}}^{(1)} \\
    \vdots    & \vdots   & \vdots \\
    z_{1_{1}}^{(m)}  & z_{1_{2}}^{(m)}  & z_{1_{3}}^{(m)} \\
  \end{bmatrix}
  \quad \text{and}\quad \mathbf{Z}_{2} =
  \begin{bmatrix}
    z_{2}^{(1)} \\ 
    \vdots \\
    z_{2}^{(m)} 
\end{bmatrix}\nonumber
\end{equation}

\item $\mathbf{W_1}$ and $\mathbf{W_2}$ are respectively $(2\times 3)$ and $(3\times 1)$ matrices as follows:
\begin{equation}
  \mathbf{W}_{1} = 
  \begin{bmatrix}
    w_{1_{11}}  & w_{1_{21}}  & w_{1_{31}} \\
    w_{1_{12}}  & w_{1_{22}}  & w_{1_{32}}
  \end{bmatrix}
  \quad \text{and}\quad \mathbf{W}_{2} =
  \begin{bmatrix}
    w_{2_{11}}  \\
    w_{2_{12}}  \\
    w_{2_{13}} 
\end{bmatrix}\nonumber
\end{equation}


\item $\mathbf{B_1}$ and $\mathbf{B_2}$ are respectively $(1\times 3)$ and $(1\times 1)$ matrices as follows:
\begin{equation}
  \mathbf{B}_{1} = 
  \begin{bmatrix}
    b_{1_{1}}  & b_{1_{2}}  & b_{1_{3}}
  \end{bmatrix}
  \quad \text{and}\quad \mathbf{B}_{2} =
  \begin{bmatrix}
    b_{2} 
\end{bmatrix}\nonumber
\end{equation}
\end{itemize}

Let's go back to the code. Following the previous comments, the weights can be initialized as
matrices: \vspace*{-1\baselineskip}
\begin{lstlisting}
W1 = np.random.random( (2, 3) )
W2 = np.random.random( (3, 1) )
\end{lstlisting}
The length of the first axis corresponds to the number of entry and
the length of the second axis corresponds to the number of
output  of the considered layer. Bias can be initialized as: \vspace*{-1\baselineskip}
\begin{lstlisting}
B1 = np.zeros( (1, 3) )
B2 = np.zeros( (1, 1) )
\end{lstlisting}
You can note here that the first axis length of bias is always equal
to one because there is only one bias by neuron. Now, implementing the
feed forward step is quite simple. In our case, it gives:
\vspace*{-1\baselineskip}
\begin{lstlisting}
        # feed forward (hidden layer)
        A1 = np.dot(X, W1) + B1
        Z1 = sigmoid(A1)
        # feed forward (output layer)
        A2 = np.dot(Z1, W2) + B2
        Z2 = sigmoid(A2)
\end{lstlisting}


\subsection{The backpropagation step}
The most difficult part of multi-layer neural network is the
implementation of the back propagation step through the gradient
descent algorithm. We take here a modified MSE loss function that gives:
\begin{equation}
  L(\mathbf{Z}_2) = \frac{1}{2} \sum\limits_{i=1}^{m} \left( z_{2}^{(i)} - t^{(i)} \right)^2\nonumber
\end{equation}
In the above case, the gradient of the loss function regarding $\mathbf{W}_1$ and $\mathbf{W}_2$  give the following tensors:
\begin{align}
   \nabla L(\mathbf{W}_{1}) &= 
  \begin{bmatrix}
    \frac{\partial L}{\partial w_{1_{11}}}  &  \frac{\partial L}{\partial w_{1_{21}}}  &  \frac{\partial L}{\partial w_{1_{31}}} \\ 
    \frac{\partial L}{\partial w_{1_{12}}}  &  \frac{\partial L}{\partial w_{1_{22}}}  &  \frac{\partial L}{\partial w_{1_{32}}}
  \end{bmatrix}\label{eq:w_12}  \\
   \nabla L(\mathbf{W}_{2}) &= \begin{bmatrix}
   \frac{\partial L}{\partial w_{2_{11}}}  & 
    \frac{\partial L}{\partial w_{2_{12}}} & 
    \frac{\partial L}{\partial w_{2_{13}}} \end{bmatrix}\nonumber 
\nonumber
\end{align}

\subsubsection{Backpropagation of the second weight layer $\mathbf{W}_{2}$}

Now, we focus on the derivative of the loss regarding $\mathbf{W}_{2}$. For the first component of $\nabla L(\mathbf{W}_{2})$, it gives:
\begin{align}
  \frac{\partial L}{\partial w_{2_{11}}}
  &=  \sum\limits_{i=1}^{m} \frac{\partial}{\partial w_{2_{11}}}\left( \frac{1}{2} \left( z_{2}^{(i)} - t^{(i)}\right)^2\right)\label{eq:delta}
\end{align}
So, the following derivative chain rule can be written:
\begin{align}
  \frac{\partial f}{\partial w_{2_{11}}} = 
  \frac{\partial  f}{\partial  z_2}\cdot 
  \frac{\partial  z_2}{\partial  a_2}\cdot  
  \frac{\partial  a_2}{\partial w_{2_{11}}} \quad \text{where} \quad
  f(z_2) = \frac{1}{2}\left( z_2 - t\right)^2\nonumber
\end{align}
It gives:
\begin{align}
  \frac{\partial f}{\partial w_{2_{11}}} = \left( z_2 - t\right)\cdot \sigma '(a_2)\cdot z_{1_{1}}\nonumber
\end{align}
So, when retrieving the sum, it gives:
\begin{align}
  \frac{\partial L}{\partial w_{2_{11}}} = \sum\limits_{i=1}^{m} \left( z_{2}^{(i)} - t^{(i)}\right)\cdot \sigma '(a_{2}^{(i)})\cdot z_{1_{1}}^{(i)}\nonumber
\end{align}

% Finally, the above formula can be written in a vectorial form as:
% \begin{align}
%   \boxed{\nabla L(\mathbf{w}_{2})  = \sum\limits_{i=1}^{m} \left( \mathbf{z}_{2_i} - \mathbf{t}_i\right)\cdot \sigma '(\mathbf{a}_{2_{i}})\cdot \mathbf{z}_{1_i}}\nonumber
% \end{align}
% % It can be implemented as follows:
% \begin{align}
%   \mathbf{w}_{2}  \rightarrow \mathbf{w}_{2} - \eta\sum\limits_{i=1}^{m} \underbrace{\left( \mathbf{z}_{2_i} - \mathbf{t}_i\right)}_{\text{\texttt{A2}}}\cdot \underbrace{\sigma '(\mathbf{a}_{2_{i}})}_{\text{\texttt{B2}}}\cdot \underbrace{\mathbf{z}_{1_i}}_{\text{\texttt{C2}}}\nonumber
% \end{align}
Finally, the gradient descent algorithm could be written in a tensorial form as:
\begin{align}
  \mathbf{W}_{2}  \rightarrow \mathbf{W}_{2} - \eta\left[ \mathbf{Z}_{1}^\intercal \cdot \left(\underbrace{\left( \mathbf{Z}_{2} - \mathbf{T}\right)}_{\text{\texttt{L2}}}\circ \underbrace{\sigma '(\mathbf{A}_{2})}_{\text{\texttt{M2}}} \right)  \right]\nonumber
\end{align}
and the related Python code is:
\vspace*{-1\baselineskip}
\begin{lstlisting}
        ## backward propagation of output layer
        L2  = Z2-T
        M2  = sigmoid_prime(A2)
        ## Compute gradients 
        Dw2 = np.dot(Z1.T, L2*M2)
        Db2 = np.sum(L2*M2, axis=0)
        ## Change weights and bias
        w2 -= eta * Dw2
        b2 -= eta * Db2
\end{lstlisting}

\subsubsection{Backpropagation of the hidden weight layer $\mathbf{W}_{1}$}
In a similar way, the derivative chain can be applied to $\mathbf{W}_{1}$ as:
\begin{align}
  \frac{\partial f}{\partial w_{1_{11}}} = 
  \frac{\partial  f}{\partial  z_2}\cdot 
  \frac{\partial  z_2}{\partial  a_{2}} \cdot  
  \frac{\partial  a_2}{\partial  z_{1_1}} \cdot  
  \frac{\partial  z_{1_1}}{\partial a_{1_1}} \cdot
  \frac{\partial  a_{1_1}}{\partial w_{1_{11}}} \quad \text{where} \quad
  f(z_2) = \frac{1}{2}\left( z_2 - t\right)^2\nonumber
\end{align}
Be aware, in the above formula, as $w_{1_{11}}$ is an input of the
first neuron of the hidden layer, the chain rule must contain the
related activation function $z_{1_1}$ and $a_{1_1}$. So, the above formula
gives:
\begin{align}
  \frac{\partial f}{\partial w_{1_{11}}} = \left( z_2 - t\right)\cdot \sigma '(a_2)\cdot w_{2_{11}} \cdot \sigma '(a_{1_1})
  \cdot x_{1}
  \nonumber
\end{align}
Again, this derivative chain rule must be included in the sum as:
\begin{align}
  \frac{\partial L}{\partial w_{1_{11}}} = \sum\limits_{i=1}^{m} \left( z_{2}^{(i)} - t^{(i)}\right)\cdot \sigma '(a_{2}^{(i)})\cdot \cdot w_{2_{11}} \cdot \sigma '(a_{1_{1}}^{(i)}) \cdot x_{1}^{(i)}
  \nonumber
\end{align}
% Finally, the above formula can be generalized as:
% \begin{align}
%    \boxed{\nabla l(\mathbf{w}_{1}) = \sum\limits_{i=1}^{m} \left( \mathbf{z}_{2}^{(i)} - t^{(i)}\right)\cdot \sigma '(\mathbf{a}_{2}^{(i)})\cdot \mathbf{w}_{2} \cdot \sigma '(\mathbf{a}_{1}^{(i)}) \cdot \mathbf{x}^{(i)}}
%   \nonumber
% \end{align}
% To operate correctly, the gradient $\nabla l(\mathbf{w}_{1})$ must be stored as a tensor (or a matrix) and this tensor must have similar dimension as $\mathbf{w}_{1}$ (see equation \ref{eq:w_12}). In the current example, it gives:
% \begin{align}
%    \nabla l(\mathbf{w}_{1}) = 
%   \begin{bmatrix}
%     \frac{\partial L}{\partial w_{1_{11}}}  &  \frac{\partial L}{\partial w_{1_{21}}}  &  \frac{\partial L}{\partial w_{1_{31}}} \\ 
%     \frac{\partial L}{\partial w_{1_{12}}}  &  \frac{\partial L}{\partial w_{1_{22}}}  &  \frac{\partial L}{\partial w_{1_{32}}}
%   \end{bmatrix}
%   \nonumber
% \end{align}

% It can be implemented as follows:
% \begin{align}
%   \mathbf{w}_{1}  \rightarrow \mathbf{w}_{1} - \eta\sum\limits_{i=1}^{m} \overbrace{\underbrace{\left( \mathbf{z}_{2_i} - \mathbf{t}_i\right)}_{\text{\texttt{A2}}}\cdot \underbrace{\sigma '(\mathbf{a}_{2_{i}})}_{\text{\texttt{B2}}}\cdot \mathbf{w}_{2}}^{\text{\texttt{A1}}}\cdot \overbrace{\sigma '(\mathbf{a}_{1_i})}^{\text{\texttt{B1}}} \cdot \overbrace{\mathbf{x}_{i}}^{\text{\texttt{C1}}}
%   \nonumber
% \end{align}
Finally, the gradient descent algorithm could be written in a tensorial form as:
\begin{align}
  \mathbf{W}_{1}  \rightarrow \mathbf{W}_{1} - \eta \left[\mathbf{X}^\intercal \cdot \left( \overbrace{\left(\left(\text{\texttt{L2}}\circ \text{\texttt{M2}}\right)  \cdot \mathbf{W}_{2}^\intercal \right)}^{\text{\texttt{L1}}} \circ \overbrace{\sigma '(\mathbf{A}_{1})}^{\text{\texttt{M1}}} \right)\right]
  \nonumber
\end{align}
and the related Python code is:
\vspace*{-1\baselineskip}
\begin{lstlisting}
        ## backward propagation of hidden layer
        L1 = np.dot(L2*M2, w2.T)
        M1 = sigmoid_prime(A1)
        ## Compute gradients 
        Dw1 = np.dot(X.T, L1*M1)
        Db1 = np.sum(L1*M1, axis=0)
        ## Change weights and bias
        w1 -= eta * Dw1
        b1 -= eta * Db1
\end{lstlisting}


\subsection{Full implementation code}
The full implementation of the multi-layer neural network able to deal
with non-linear separable data is given in the next listing.

\lstinputlisting[firstline=14, lastline=87, caption=\dlIA{multi-layer.py}]{../script/ia/multi-layer.py}

The full python code is also downloadable
at \footnote{\dlIA{multi-layer.py}}.  As you can see in the following
chart, the provided algorithm is able to classify non-linear separable
data provided by the \texttt{make\_moons} function.
\begin{center}
  \includegraphics[width=.6\linewidth]{multi-layer-full}
\end{center}

\begin{manip}
 To train yourself, you can try to add the following features to the previous code:
 \begin{enumerate}
 \item monitoring of the \textit{loss} versus \textit{epoch}
 \item change the \texttt{make\_moons} generator by \texttt{make\_circle}. You must obtain something like this:
   \begin{center}
     \includegraphics[width=.8\linewidth]{circle}
   \end{center}
 \end{enumerate}
\end{manip}

Now, we will move on a more practical and real case. This is a multi-classification problem that involves hand-written digits.


\section{Hello world of ML: multi-classification of hand-written digits}
This section will be dedicated to a practical work. This is a direct
application of what we have learned in the previous sections! This
problem is inspired from a real one and is considered as the
\texttt{"hello world"} of machine learning. It consists in making a
machine able to recognize hand-written digits.

\subsection{Autopsy of data}
Here, we will use already-classified data that comes from the
\texttt{datasets.load\_digits} function of the \texttt{sklearn}
module. Let's take a look on this data with the interpreter:
\vspace*{-1\baselineskip}
\begin{lstlisting}
>>> from sklearn.datasets import load_digits
>>> digits = load_digits()
>>> print(digits.data.shape)
(1797, 64)
\end{lstlisting}
As you can see in the above code, the \texttt{data} variable is a
numpy array that contains 1797 values of 64-dimensional data. For
pedagogical reasons, we have still treated only 2-dimensional data compatible with
(X,Y) 2D plotting. Here, it is not possible to draw all this data on
a single chart. However, we can plot the first data set as follows:
\vspace*{-1\baselineskip}
\begin{lstlisting}
>>> import matplotlib.pyplot as plt 
>>> plt.gray() 
>>> plt.matshow(digits.images[0]) 
>>> plt.show() 
\end{lstlisting}
You must see something like this:
\begin{center}
  \svg{.3\linewidth}{./img/digit_0.pdf_tex}
\end{center}
As you can see, this first data set is related to a hand written
digit '\texttt{0}'. Let's see how this image is stored.
\vspace*{-1\baselineskip}
\begin{lstlisting}
>>> print(digits.images[0].shape)
(8, 8)
\end{lstlisting}
The handwritten digit was digitized in black and white using
$(8\times 8)$ matrices. As you can see in the previous figure, the
first component of the matrix of coordinates $(0,\ 0)$ corresponds to
the pixel located at the top-left corner of the image. Let's see the content of this
matrix.  \vspace*{-1\baselineskip}
\begin{lstlisting}
>>> print(digits.images[0])
[[  0.   0.   5.  13.   9.   1.   0.   0.]
 [  0.   0.  13.  15.  10.  15.   5.   0.]
 [  0.   3.  15.   2.   0.  11.   8.   0.]
 [  0.   4.  12.   0.   0.   8.   8.   0.]
 [  0.   5.   8.   0.   0.   9.   8.   0.]
 [  0.   4.  11.   0.   1.  12.   7.   0.]
 [  0.   2.  14.   5.  10.  12.   0.   0.]
 [  0.   0.   6.  13.  10.   0.   0.   0.]]
\end{lstlisting}
As you can see, each pixel of the image takes an integer value in the
range $[0,1,2,\hdots,15]$. These values are related to the
pixel grayscale. It means that 16 different gray values are
allowed. The following grayscale drawing highlights the different
grays with their related values. It starts from \texttt{0}, that
corresponds to the full black color and it ends by \texttt{15} that
corresponds to a full white color.
\begin{center}
  \svg{\linewidth}{./img/grayscale.pdf_tex}
\end{center}
However, it is not possible to train a neural network with this kind
of data. Remember that the input of a neural network for one single
data set $i$ is not a matrix but a vector as:
\begin{equation} 
  \mathbf{x}^{(i)} = 
  \begin{bmatrix}
    x_{1}^{(i)}  &
    x_{2}^{(i)}  &
    \hdots  &
    x_{n}^{(i)} 
\end{bmatrix}
\end{equation}
So, image matrices must be flattened from $(8\times 8)$ matrices to
 $(8\times 8)=(64)$ length vectors. This kind of data was already formatted for
us in the \texttt{digits.data} variable. As you can see in the
following listing, the \texttt{digits.data} contains the previous
matrix in a flattened format.  \vspace*{-1\baselineskip}
\begin{lstlisting}
>>> print(digits.data[0])
[  0.   0.   5.  13.   9.   1.   0.   0.   0.   0.  13.  15.  10.  15.   5.
   0.   0.   3.  15.   2.   0.  11.   8.   0.   0.   4.  12.   0.   0.   8.
   8.   0.   0.   5.   8.   0.   0.   9.   8.   0.   0.   4.  11.   0.   1.
  12.   7.   0.   0.   2.  14.   5.  10.  12.   0.   0.   0.   0.   6.  13.
  10.   0.   0.   0.]
\end{lstlisting}
\begin{info}
  Note that this process can be easily given thanks to the
  \texttt{flatten()} method of the \texttt{numpy.array} class. The following
  snippet shows its usage.
  \vspace*{-1\baselineskip}
\begin{lstlisting}
>>> print(digits.images[0].flatten())
[  0.   0.   5.  13.   9.   1.   0.   0.   0.   0.  13.  15.  10.  15.   5.
   0.   0.   3.  15.   2.   0.  11.   8.   0.   0.   4.  12.   0.   0.   8.
   8.   0.   0.   5.   8.   0.   0.   9.   8.   0.   0.   4.  11.   0.   1.
  12.   7.   0.   0.   2.  14.   5.  10.  12.   0.   0.   0.   0.   6.  13.
  10.   0.   0.   0.]
\end{lstlisting}
\end{info}

To conclude this part, the \texttt{digits.data} numpy array contains
1797 grayscale images. Each image is stored in a 64 length vector
that corresponds to the flattened format of a $(8\times 8)$ matrix of gray-scale pixels. The
grayscale is coded with 16 different integer numbers in the $[0,1,2,\hdots,15]$ range.
\begin{info}
  In fact, the gray scale is coded on 4 bits $\rightarrow 2^4 = 16$!
\end{info}


\subsection{Autopsy of the related labels}
Now, we will focus on data classification. The classification is
accessible from the \texttt{digits.target} arrays. As expected, the
\texttt{digits.target} contains 1797 items.  \vspace*{-1\baselineskip}
\begin{lstlisting}
>>> print(digits.target.shape)
(1797,)
\end{lstlisting}
Each item contains a number in the
$[0,1,2,\hdots,9]$ range that corresponds to the hand-written digit. Note that the
classification was done by humans.
\begin{info}
  Machine learning processes that involve already-classified data by
  humans are known as \textbf{supervised} learning.
\end{info}
\vspace*{-1\baselineskip}
\begin{lstlisting}
>>> print(digits.target)
[0 1 2 ..., 8 9 8]
\end{lstlisting}
For example, if we take the first item number:
\vspace*{-1\baselineskip}
\begin{lstlisting}
>>> print(digits.target[0])
0
\end{lstlisting}
as expected, you can see that it corresponds to the zero value which
is the value of the handwritten digit (see the image in the previous
section). However, based on our previous implementations, neural
networks can deal only with binary classification problem which the
expected answer is YES or NO.



\subsection{from multi-classification to binary classification problem}
As shown in the previous section, the proposed format of label
classification does not match our expectations.  Here, we are facing a
multi-classification problem. An input must be classified into
several classes. Here, ten classes are possible. They correspond to
the digit numbers $[0,1,2,\hdots,9]$. To fix this issue, a possible
trick is to transform this multi-classification problem into 10
different binary classification problems.

In other words, we will transform the initial question (that can take 10 different answers):
\begin{itemize}
\item \textit{which digit number is written on this image?}\dotfill\textsf{0,1,2,3,4,5,6,7,8 or 9?}
\end{itemize}
 into 10 different questions which
required binary answers:
\begin{itemize}
\item \textit{is zero written on this image?}\dotfill\textsf{Yes or No?}
\item \textit{is one written on this image?}\dotfill\textsf{Yes or No?}
\item \textit{is two written on this image?}\dotfill\textsf{Yes or No?}
\item \textit{is three written on this image?}\dotfill\textsf{Yes or No?}
\item \textit{is four written on this image?}\dotfill\textsf{Yes or No?}
\item \textit{is five written on this image?}\dotfill\textsf{Yes or No?}
\item \textit{is six written on this image?}\dotfill\textsf{Yes or No?}
\item \textit{is seven written on this image?}\dotfill\textsf{Yes or No?}
\item \textit{is eight written on this image?}\dotfill\textsf{Yes or No?}
\item \textit{is nine written on this image?}\dotfill\textsf{Yes or No?}
\end{itemize}
To make it possible, the \texttt{digits.target} variable must be
changed. Here, each single value of the \texttt{digits.target} array
that can take the \texttt{'0'}, \texttt{'1'}, \texttt{'2'},
\texttt{'3'}, \texttt{'4'}, \texttt{'5'}, \texttt{'6'}, \texttt{'7'},
\texttt{'8'} or \texttt{'9'} values is replaced by a ten length array
that can take \texttt{'0'} or \texttt{'1'}. This process can be summarized as:
\begin{equation}
  \underbrace{\text{\texttt{5}}}_{\text{single value: \texttt{5}}}\rightarrow \underbrace{\text{\texttt{[0, 0, 0, 0, 0, 1, 0, 0, 0, 0]}}}_{\text{10 length array where the 5$^{\text{th}}$ item is \texttt{1}}}\nonumber
\end{equation}
This transformation must be done to all values stored in
the \texttt{digits.target} array. It can be easily done thanks to
\texttt{np.eye()} function that comes from Numpy. It gives:
\vspace*{-1\baselineskip}
\begin{lstlisting}
>>> print(digits.target)
[0 1 2 ..., 8 9 8]
>>> label = np.eye(10)[digits.target]
>>> print(label)
[[ 1.  0.  0. ...,  0.  0.  0.]
 [ 0.  1.  0. ...,  0.  0.  0.]
 [ 0.  0.  1. ...,  0.  0.  0.]
 ..., 
 [ 0.  0.  0. ...,  0.  1.  0.]
 [ 0.  0.  0. ...,  0.  0.  1.]
 [ 0.  0.  0. ...,  0.  1.  0.]]
\end{lstlisting}
It's really a nice trick! Again, Numpy is really incredible \texttt{:)}


\subsection{Try it yourself!}
Let's suppose the following architecture composed by a two levels
neural network, where:
\begin{itemize}
\item the number of entry $\mathbf{X}$ is 64,
\item the number (noted $N_1$) of hidden neurons $\mathbf{Z}_1$ is unknown,
\item the number of output $\mathbf{Y}$ is 10,
\item the first activation function is the \textit{Relu} function defined as:
  \begin{equation}
  \Omega(a) = \left\{
    \begin{array}{rl}
         a & \mbox{if } a>0 \\
         0 & \mbox{otherwise}
    \end{array}
\right.\nonumber
\end{equation}
\item the second activation function is the well-known \textit{Sigmoid} function.
\end{itemize}

\begin{center}
  \svg{1\linewidth}{./img/multi-layer-digit.pdf_tex}
\end{center}

Now, based on our previous implementation, you can code this neural network by
yourself . To make it, you can follow the proposed steps.
\resetquestion

\begin{task}
  Similarly to the \texttt{sigmoid()} and \texttt{sigmoid\_prime()} functions, implement the \texttt{relu()} and
  \texttt{relu\_prime()} functions. You should obtain
  something like this: \vspace*{-1\baselineskip}
\begin{lstlisting}
def sigmoid(x):
    return 1 / (1 + np.exp(-x))

def sigmoid_prime(x):
    z = sigmoid(x)
    return z * (1 - z)

def relu(x):
    ## ... YOUR IMPLEMENTATION HERE ...

def relu_prime(x):
    ## ... YOUR IMPLEMENTATION HERE ...

\end{lstlisting}
\end{task}

\begin{task}
  Get the data thanks to the \texttt{load\_digits()} function that comes from
  the \texttt{sklearn.datasets} module. Place the input data in a variable
  named \texttt{x} and the labels in a variable named \texttt{t}. You
  should obtain something like this:\vspace*{-1\baselineskip}
\begin{lstlisting}
digits = datasets.load_digits()
x =  ## ... YOUR IMPLEMENTATION HERE ...
     ## ... 
t =  ## ... YOUR IMPLEMENTATION HERE ...
     ## ... 
   \end{lstlisting}
\textit{Don't forget to apply the treatments described in the last section!}
\end{task}

\begin{task}
  Initialize weight and bias. In a first try, you can take the number
  of hidden neurons $N_1=10$. You should obtain something like this:
\vspace*{-1\baselineskip}
\begin{lstlisting}
# number of outputs
N1 = # ... YOUR NUMBER HERE ... # <- input number
N2 = # ... YOUR NUMBER HERE ... # <- hidden layer number
N3 = # ... YOUR NUMBER HERE ... # <- output number

# initialize weight
W1 = np.random.random((N1, N2)) / np.sqrt(N1)
W2 = np.random.random((N2, N3)) / np.sqrt(N2)

#initialize bias 
B1 = np.zeros((1, N2))
B2 = np.zeros((1, N3))
   \end{lstlisting}
\end{task}
In the above script, you can see a new trick for the weights. Weights
are randomly initialized in the $[0,1]$ range and divided by the root
squared of the entry number. This trick allows to avoid saturation of
the backpropagation method. This saturation is generally given by the
derivation of the Sigmoid function that tends to zero for high input
values. The following chart highlights this behavior.
\begin{center}
  \svg{0.7\linewidth}{./img/sig-prime.pdf_tex}
\end{center}
When the result of $\sigma'(x)$ tends to zero, the backpropagation method
has no effect because the correction factors $\Delta w$ and $\Delta b$
tend to null values.

\begin{task}
  Implement the feed forward step with the mini-batch approach
\end{task}

\begin{task}
  Implement the back propagation method using stochastic gradient descent algorithm
\end{task}

\begin{task}
  Monitor the evolution of loss versus epochs and check your full algorithm. The loss must decrease to zero.
\end{task}

\begin{task}
  Apply the trained neural network to the full data set in order to count the
  occurrence of good prediction. You must obtain something like 
  90\% of correct prediction.
\end{task}
Here, a problem appears. The validation process involves the same data
set which was used during the learning step. A better approach
involves two different data set:
\begin{enumerate}
\item the first part of the data set is reserved to the learning
  process. This set is called the \textbf{training sample}.
\item The second part of the data set is reserved for evaluating the
  learning process. This set is called the \textbf{validation sample}.
\end{enumerate}

\begin{task}
  Separate your data in two different samples: the
  \textit{training sample} and the \textit{validation sample}. Monitor
  the losses of these two data sets. 
\end{task}

If your code is right, you should obtain something like that.
\begin{center}
  \svg{1.0\linewidth}{./img/loss-valid.pdf_tex}
\end{center}

If you take a look at the whole figure scale, the validation sample
looks flat. Indeed, if you make a zoom (see the right chart), the
validation sample goes down to an optimal value. This value is
characterized by a minimal loss value for a given epoch number. Below
this number, the neural network is \textit{under-trained} and above
this epoch number, the machine is \textit{over-trained}. The
over-trained behavior is not obvious. It should be considered as an
over optimization of the weights and bias regarding the training data
sample. You can observe it by zooming on the train sample: the
related loss decreases continuously while the validation loss
increases.  Over-trained is really common in machine learning and
should be proscribed.  It can be detected only if you use separated
data for training and validating. That's why data separation is really
important.

Now, you can use this metrics to choose an optimum value of epoch,
hidden layer number, mini-batch size... This step, that consist in
tuning the meta parameters of a neural network is called
\textit{meta-optimization}.

\begin{info}
  To avoid \textit{meta-optimization} overfitting, a good practice is
  to keep separately a third data set. This unused data sample will be
  devoted only for ultimate validating. It allows to prevent for
  too much aggressive \textit{meta-optimization}.
\end{info}

\begin{task}
  Process to \textit{meta-optimization} in order find an optimal set
  of parameters for your neural network.
\end{task}

\begin{center}
{\sffamily \textbf{You can download the correction here}:  \dlIA{digit.py}}
\end{center}

\section{Conclusion}
In this part, we have coded from scratch single layer and multi-layer
neural networks. It allows us to understand the main features of ML:
feed forward, back propagation, over-fitting, etc. Indeed, coding from
scratch is good for understanding but not really efficient. If you
need professional ML usage, my advice is to use ML modules such as
\textit{Keras} or \textit{Scikit-learn}. With this course, that
introduces the basis of ML, you are now aware about the main concepts
of ML that are required to take in hand these modules. Of course, you can
also continue to learn by yourself. A lot of courses and tutorial are available on the
web. Thanks to this resources, you may over-fit yourself in ML!:)


